import { Message } from './messages.js';
import { NetMessage } from './types/NetMessages.js';
import { SourceDemoBuffer } from './buffer.js';
import { GameEventManager } from './types/GameEventManager.js';
import { SourceGame } from './speedrun/games/SourceGame.js';
export declare class SourceDemo {
    demoFileStamp?: string;
    demoProtocol?: number;
    networkProtocol?: number;
    serverName?: string;
    clientName?: string;
    mapName?: string;
    gameDirectory?: string;
    playbackTime?: number;
    playbackTicks?: number;
    playbackFrames?: number;
    signOnLength?: number;
    messages?: Message[];
    game?: SourceGame;
    gameEventManager?: GameEventManager;
    static default(): SourceDemo;
    isNewEngine(): boolean;
    findMessage<T extends Message>(type: (new (type: number) => T) | ((msg: Message) => boolean)): T | undefined;
    findMessages<T extends Message>(type: (new (type: number) => T) | ((msg: Message) => boolean)): T[];
    findPacket<T extends NetMessage>(type: (new (type: number) => T) | ((packet: NetMessage) => boolean)): T | undefined;
    findPackets<T extends NetMessage>(type: (new (type: number) => T) | ((packet: NetMessage) => boolean)): T[];
    readHeader(buf: SourceDemoBuffer): this;
    writeHeader(buf: SourceDemoBuffer): this;
    readMessages(buf: SourceDemoBuffer): this;
    writeMessages(buf: SourceDemoBuffer): void;
    readUserCmds(): this;
    writeUserCmds(): this;
    readStringTables(): this;
    writeStringTables(): this;
    readDataTables(): this;
    writeDataTables(): this;
    readPackets(netMessages?: (typeof NetMessage | undefined)[]): this;
    writePackets(): this;
    detectGame(sourceGames?: SourceGame[]): this;
    getIntervalPerTick(): number;
    getTickrate(): number;
    adjustTicks(): this;
    adjustRange(endTick?: number, startTick?: number, tickrate?: number | undefined): this;
    rebaseFrom(tick: number): this;
    getSyncedTicks(demo: SourceDemo, viewTolerance?: number, splitScreenIndex?: number): {
        source: number | undefined;
        destination: number | undefined;
        delta: number;
        x: number | undefined;
        y: number | undefined;
        z: number | undefined;
    }[];
}
